# coding: utf-8

"""
    Magneto API

    Magneto API is the RESTful API for the Rely.io platform.

    The version of the OpenAPI document: v0.0.1
    Contact: contact@rely.io
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List
from typing_extensions import Annotated
from magneto_api_client.models.scorecard_result_rule import ScorecardResultRule
from typing import Optional, Set
from typing_extensions import Self

class ScorecardResultUpdate(BaseModel):
    """
    Scorecard Result Update Model.
    """ # noqa: E501
    scorecard_id: Annotated[str, Field(strict=True)] = Field(alias="scorecardId")
    entity_id: Annotated[str, Field(strict=True)] = Field(alias="entityId")
    current_rank: StrictStr = Field(alias="currentRank")
    rules: Dict[str, ScorecardResultRule]
    additional_properties: Dict[str, Any] = {}
    __properties: ClassVar[List[str]] = ["scorecardId", "entityId", "currentRank", "rules"]

    @field_validator('scorecard_id')
    def scorecard_id_validate_regular_expression(cls, value):
        """Validates the regular expression"""
        if not re.match(r"^([a-z0-9_.-]+)$", value):
            raise ValueError(r"must validate the regular expression /^([a-z0-9_.-]+)$/")
        return value

    @field_validator('entity_id')
    def entity_id_validate_regular_expression(cls, value):
        """Validates the regular expression"""
        if not re.match(r"^([a-z0-9_.-]+)$", value):
            raise ValueError(r"must validate the regular expression /^([a-z0-9_.-]+)$/")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of ScorecardResultUpdate from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        * Fields in `self.additional_properties` are added to the output dict.
        """
        excluded_fields: Set[str] = set([
            "additional_properties",
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each value in rules (dict)
        _field_dict = {}
        if self.rules:
            for _key_rules in self.rules:
                if self.rules[_key_rules]:
                    _field_dict[_key_rules] = self.rules[_key_rules].to_dict()
            _dict['rules'] = _field_dict
        # puts key-value pairs in additional_properties in the top level
        if self.additional_properties is not None:
            for _key, _value in self.additional_properties.items():
                _dict[_key] = _value

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of ScorecardResultUpdate from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "scorecardId": obj.get("scorecardId"),
            "entityId": obj.get("entityId"),
            "currentRank": obj.get("currentRank"),
            "rules": dict(
                (_k, ScorecardResultRule.from_dict(_v))
                for _k, _v in obj["rules"].items()
            )
            if obj.get("rules") is not None
            else None
        })
        # store additional fields in additional_properties
        for _key in obj.keys():
            if _key not in cls.__properties:
                _obj.additional_properties[_key] = obj.get(_key)

        return _obj


